unit P_SQLdefine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mask, Buttons, Spin, DosMove, DsPanel, Db, DBTables, INI;

type
  TForm_SQLdefine = class(TForm)
    Label1: TLabel;
    meditSQL: TMaskEdit;
    Label4: TLabel;
    lbxName: TListBox;
    lbxSQL: TListBox;
    eScript: TEdit;
    seditLeft: TSpinEdit;
    seditRight: TSpinEdit;
    cbxAnd: TComboBox;
    cbxLike2: TComboBox;
    cbxLike1: TComboBox;
    Label10: TLabel;
    Label11: TLabel;
    cbxMethod: TComboBox;
    cbxField: TComboBox;
    Label7: TLabel;
    Label13: TLabel;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Panel_Space: TPanel;
    seditSpace: TSpinEdit;
    Label14: TLabel;
    Label2: TLabel;
    DosMove1: TDosMove;
    Panel_Field: TDsPanel;
    Table_SQL: TTable;
    Table_SQLSQLname: TStringField;
    Table_SQLSQLscript: TStringField;
    Label6: TLabel;
    Label15: TLabel;
    Label12: TLabel;
    Label9: TLabel;
    DS_Result: TDataSource;
    eList: TEdit;
    btn_Run: TBitBtn;
    btn_Check: TBitBtn;
    btn_Save: TBitBtn;
    btn_Load: TBitBtn;
    btn_Cancel: TBitBtn;
    BitBtn1: TBitBtn;
    btn_Add: TBitBtn;
    btn_Insert: TBitBtn;
    btn_Remove: TBitBtn;
    btn_Edit: TBitBtn;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    Label3: TLabel;
    cbxSelect: TCheckBox;
    Label8: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btn_AddClick(Sender: TObject);
    procedure btn_CancelClick(Sender: TObject);
    procedure btn_RemoveClick(Sender: TObject);
    procedure btn_InsertClick(Sender: TObject);
    procedure btn_SaveClick(Sender: TObject);
    procedure btn_LoadClick(Sender: TObject);
    procedure cbxFieldChange(Sender: TObject);
    procedure lbxNameClick(Sender: TObject);
    procedure lbxSQLClick(Sender: TObject);
    procedure btn_CheckClick(Sender: TObject);
    procedure btn_TestClick(Sender: TObject);
    procedure btn_RunClick(Sender: TObject);
    procedure btn_DesignClick(Sender: TObject);
    procedure eListExit(Sender: TObject);
    procedure btn_EditClick(Sender: TObject);
    procedure cbxSelectClick(Sender: TObject);
  private
    { Private declarations }
    SQLname: string;
    SQLscript: string;
    nSQLfield: string;
    nSQLfilter: string;
    nSQLstring: string;
    addType: string;
    rQuery: TQuery;
    function AddSQL: boolean;
  public
    { Public declarations }
  end;

var
  Form_SQLdefine: TForm_SQLdefine;
  const stringand: array[0..1] of string = ('and','or ');
  const stringmethod: array[0..9] of string = ('=','<','>','<=','>=','<>',
                                               'in','not in','like','not like');

implementation

uses P_SQLbrowse, P_DataBase;

{$R *.DFM}

function TForm_SQLdefine.AddSQL: boolean;
          var i: integer;
              andIndex: integer;
              FieldIndex: integer;
              MethodIndex: integer;
              space: string;
begin
     result:= False;
     andIndex:= cbxAnd.ItemIndex;
     FieldIndex:= cbxField.ItemIndex;
     MethodIndex:= cbxMethod.ItemIndex;
     if (trim(cbxField.Text)='') or (FieldIndex=-1) then begin
        Application.MessageBox('пܤ@ӥTW','~',MB_ICONERROR+MB_OK);
        cbxField.SetFocus;
        exit;
     end;
     if (trim(cbxMethod.Text)='') or (MethodIndex=-1) then begin
        Application.MessageBox('пܤ@ئXk⦡','~',MB_ICONERROR+MB_OK);
        cbxMethod.ItemIndex:= 0;
        cbxMethod.SetFocus;
        exit;
     end;
     if (lbxName.Items.Count > 0) and
        (((lbxName.ItemIndex>0) and (addType='INSERT')) or
         (addType='ADD')) then
        if (trim(cbxAnd.Text)='') or (AndIndex=-1) then begin
           Application.MessageBox('hձпܤ@سs覡','~',MB_ICONERROR+MB_OK);
           cbxAnd.ItemIndex:= 0;
           cbxAnd.SetFocus;
           exit;
        end;

     // yz
     space:= '';
     for i:= 1 to seditSpace.Value do space:= space+' ';

     SQLname:= '';
     // and , pGbĤ@, ׬O_ܤ@ߤ[
     if (AndIndex>=0) and (lbxName.Items.Count > 0) and 
        (((lbxName.ItemIndex>0) and (addType='INSERT')) or
         (addType='ADD')) then SQLname:= cbxAnd.Text+' '
     else SQLname:= '   ';
     // (
     for i:= 1 to seditLeft.Value do SQLname:= SQLname+'(';
     // field
     SQLname:= SQLname+trim(cbxField.Text)+' ';
     // =
     if (MethodIndex in [6,7]) then
          SQLname:= SQLname+cbxMethod.Text+' ('
     else if aftAry[FieldIndex].fdTypeID='N' then
          SQLname:= SQLname+cbxMethod.Text+' '
     else if (aftAry[FieldIndex].fdTypeID='A') or
             (aftAry[FieldIndex].fdTypeID='D') then SQLname:= SQLname+
                                                              cbxMethod.Text+' "';
     // text
     SQLname:= SQLname+trim(cbxLike1.Text);
     SQLname:= SQLname+trimRight(meditSQL.Text)+space;
     SQLname:= SQLname+trim(cbxLike2.Text);
     if (MethodIndex in [6,7]) then SQLname:= SQLname+')'
     else if (aftAry[FieldIndex].fdTypeID='A') or
             (aftAry[FieldIndex].fdTypeID='D') then SQLname:= SQLname+'"';
     // )
     for i:= 1 to seditRight.Value do SQLname:= SQLname+')';

     // SQL yk
     SQLscript:= '';
     // and , pGbĤ@, hJʧ@׬O_ܤ@ߤ[J
     if (AndIndex>=0) and (lbxName.Items.Count > 0) and 
        (((lbxName.ItemIndex>0) and (addType='INSERT')) or
         (addType='ADD')) then SQLscript:= stringAnd[AndIndex]+' '
     else SQLscript:= '    ';
     // (
     for i:= 1 to seditLeft.Value do SQLscript:= SQLscript+'(';
     // field
     SQLscript:= SQLscript+trim(aftAry[cbxField.ItemIndex].fdfieldName);
     // =
     if (MethodIndex in [6,7]) then  // in, not in
          SQLscript:= SQLscript+' '+stringMethod[MethodIndex]+' ('
     else if (MethodIndex in [8,9]) then  // like, not like
          SQLscript:= SQLscript+' '+stringMethod[MethodIndex]+' "'
     else if aftAry[FieldIndex].fdTypeID='N' then
          SQLscript:= SQLscript+stringMethod[MethodIndex]
     else if (aftAry[FieldIndex].fdTypeID='A') or
             (aftAry[FieldIndex].fdTypeID='D')
     then SQLscript:= SQLscript+stringMethod[MethodIndex]+'"';
     SQLscript:= SQLscript+trim(cbxLike1.Text);
     SQLscript:= SQLscript+trimRight(meditSQL.Text)+space;
     SQLscript:= SQLscript+trim(cbxLike2.Text);
     if (MethodIndex in [6,7]) then SQLscript:= SQLscript+')'
     else if (aftAry[FieldIndex].fdTypeID='A') or
             (aftAry[FieldIndex].fdTypeID='D')
     then SQLscript:= SQLscript+'"';
     // )
     for i:= 1 to seditRight.Value do SQLscript:= SQLscript+')';
     seditSpace.Value:= 0;
     result:= True;
end;

procedure TForm_SQLdefine.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     rQuery.Free;
     Action:= caFree;
     Form_SQLdefine:= nil;
end;

procedure TForm_SQLdefine.FormCreate(Sender: TObject);
          var i: integer;
              DBfile: string;
begin
     // ]w field combobox 
     rQuery:= TQuery.Create(self);
     rQuery.Name:= 'Query_Result';
     rQuery.DatabaseName:= ExtractFilePath(DBfile);
     DS_Result.DataSet:= rQuery;
     rQuery.SQL.Clear;
     if not cbxSelect.Checked then nSQLfield:=' * '
     else nSQLfield:= '';
     for i:= 0 to aQueryCount-1 do begin
         cbxField.Items.Add(aftAry[i].fdfieldName);
         if cbxSelect.Checked then begin
            if i = 0 then nSQLfield:= aftAry[i].fdfieldName
            else nSQLfield:= nSQLfield+', '+aftAry[i].fdfieldName;
         end;
     end;
     cbxMethod.ItemIndex:= 0;
end;

procedure TForm_SQLdefine.FormActivate(Sender: TObject);
begin
     cbxField.SetFocus;
end;

procedure TForm_SQLdefine.btn_AddClick(Sender: TObject);
begin
     addType:= 'ADD';
     if Form_SQLdefine.AddSQL then begin
        lbxName.Items.Add(SQLname);
        lbxSQL.Items.Add(SQLscript);
        lbxSQL.ItemIndex:= lbxName.ItemIndex;
     end;
end;

procedure TForm_SQLdefine.btn_InsertClick(Sender: TObject);
          var NameNo: integer;
begin
     addType:= 'INSERT';
     NameNo:= lbxName.ItemIndex;
     if NameNo=-1 then begin
        Application.MessageBox('нTwnJyz_','~',MB_ICONERROR+MB_OK);
        exit;
     end;
     if Form_SQLdefine.AddSQL then begin
        lbxName.Items.Insert(NameNo,SQLname);
        lbxSQL.Items.Insert(NameNo,SQLscript);
     end;
end;

procedure TForm_SQLdefine.btn_CancelClick(Sender: TObject);
begin
     Form_SQLdefine.Close;
end;

procedure TForm_SQLdefine.btn_RemoveClick(Sender: TObject);
begin
     lbxName.Items.Delete(lbxName.ItemIndex);
     lbxSQL.Items.Delete(lbxSQL.ItemIndex);     
end;

procedure TForm_SQLdefine.btn_SaveClick(Sender: TObject);
          var Table: TTable;
              i: integer;
              sqlfile: string;
begin
     if SaveDialog1.Execute then begin
        sqlfile:= SaveDialog1.FileName;
        // إ߸Ʈw
        Table:= TTable.Create(self);
        with Table do begin
             DatabaseName:= ExtractFilePath(sqlfile);
             TableType:= ttParadox;
             TableName:= ExtractFileName(sqlfile);
             with FieldDefs do begin
                Add('SQLname',ftString,255,False);
                Add('SQLscript',ftString,255,False);
             end;
             CreateTable;
             Free;
        end;
        // sJ
        Table_SQL.DatabaseName:= ExtractFilePath(sqlfile);
        Table_SQL.TableType:= ttParadox;
        Table_SQL.TableName:= ExtractFileName(sqlfile);
        Table_SQL.Open;
        for i:= 0 to lbxName.Items.Count-1 do begin
            Table_SQL.Append;
            Table_SQLSQLname.Value  := lbxName.Items[i];
            Table_SQLSQLscript.Value:= lbxSQL.Items[i];
            Table_SQL.Post;
        end;
        Table_SQL.Close;
     end;
end;

procedure TForm_SQLdefine.btn_LoadClick(Sender: TObject);
begin
     if OpenDialog1.Execute then begin
        if lbxName.Items.Count <> 0 then begin
           if ID_NO = Application.MessageBox('sJ|Mثe]w'+#13+
                                              'O_Tw?','ĵi',
                                              MB_ICONWARNING+
                                              MB_YESNO+MB_DEFBUTTON2) then exit;
        end;
        // Mثe
        lbxName.Clear;
        lbxSQL.Clear;
        eScript.Clear;

        // J
        Table_SQL.DatabaseName:= ExtractFilePath(OpenDialog1.FileName);
        Table_SQL.TableType:= ttParadox;
        Table_SQL.TableName:= ExtractFileName(OpenDialog1.FileName);
        Table_SQL.Open;
        Table_SQL.First;
        while not Table_SQL.Eof do begin
              lbxName.Items.Add(Table_SQLSQLname.Value);
              lbxSQL.Items.Add(Table_SQLSQLscript.Value);
              Table_SQL.Next;
        end;
        Table_SQL.Close;
     end;
end;

procedure TForm_SQLdefine.cbxFieldChange(Sender: TObject);
          var i: integer;
begin
     i:= cbxField.ItemIndex;
     if i < 0 then Panel_Field.Caption:= 'TW'
     else if aftAry[i].fdTypeID='N' then Panel_Field.Caption:= '쬰ƭȮ榡'
     else if aftAry[i].fdTypeID='A' then Panel_Field.Caption:= '쬰r榡'
     else if aftAry[i].fdTypeID='D' then Panel_Field.Caption:= '쬰榡'
     else if aftAry[i].fdTypeID='L' then Panel_Field.Caption:= '쬰޿榡'
     else                                Panel_Field.Caption:= '쬰'+aftAry[i].fdTypeS;

     if aftAry[i].fdTypeID = 'A' then begin
        if cbxMethod.Items.Count <> 10 then begin
           cbxMethod.Items.Add('ŦX');
           cbxMethod.Items.Add('t');
        end;
        cbxLike1.Visible:= True;
        cbxLike2.Visible:= True;
        Panel_Space.Visible:= True;
     end
     else begin
        // BRF@ITEM, COUNT |@, ҥH٬OR8
        cbxMethod.Items.Delete(8);
        cbxMethod.Items.Delete(8);
        cbxLike1.Visible:= False;
        cbxLike2.Visible:= False;
        Panel_Space.Visible:= False;
     end;
end;

procedure TForm_SQLdefine.lbxNameClick(Sender: TObject);
begin
     lbxSQL.ItemIndex:= lbxName.ItemIndex;
     if eList.ReadOnly then eList.Text:= lbxSQL.Items.Strings[lbxSQL.ItemIndex];     
end;

procedure TForm_SQLdefine.lbxSQLClick(Sender: TObject);
begin
     lbxName.ItemIndex:= lbxSQL.ItemIndex;
     if eList.ReadOnly then eList.Text:= lbxSQL.Items.Strings[lbxSQL.ItemIndex];
end;

procedure TForm_SQLdefine.btn_CheckClick(Sender: TObject);
          var i: integer;
begin
     if lbxName.Items.Count>0 then begin
         nSQLfilter:= ' where ';
         for i:= 0 to lbxName.Items.Count-1 do nSQLfilter:= nSQLfilter+' '+
                                                            trim(lbxSQL.Items[i])+' ';
     end
     else nSQLfilter:= '';
     nSQLstring:= 'select '+nSQLfield+' from '+
                  ExtractFileName(DBfile)+' '+
                  nSQLfilter;
     eScript.Text:= nSQLstring;
     btn_Run.Enabled:= False;     
end;

procedure TForm_SQLdefine.btn_TestClick(Sender: TObject);
          var nSQLstring1: string;
begin
     nSQLstring1:= trim(eScript.Text);
     rQuery.Close;
     rQuery.SQL.Clear;
     rQuery.SQL.Text:= nSQLstring1;
     try
        rQuery.Open;
     except
        on E:Exception do begin
           Application.MessageBox(pChar(']wykD!'+#13+E.Message),
                                  '~',MB_ICONERROR+MB_OK);
           rQuery.Close;
           btn_Run.Enabled:= False;
        end;
     end;

     try
        Form_SQLbrowse:= TForm_SQLbrowse.Create(self);
        Form_SQLbrowse.Top   :=   0;
        Form_SQLbrowse.Left  :=   0;
        Form_SQLbrowse.Width := 800;
        Form_SQLbrowse.Height:= 250;
        Form_SQLbrowse.ShowModal;
     finally
        Form_SQLbrowse.Free;
        btn_Run.Enabled:= True;
     end;
end;

procedure TForm_SQLdefine.btn_RunClick(Sender: TObject);
begin
     SQLstring:= SQLfield+nSQLfilter+SQLorder;
     SQLfilter:= nSQLfilter;
     Form_SQLdefine.Close;
end;

procedure TForm_SQLdefine.btn_DesignClick(Sender: TObject);
begin
     eList.ReadOnly:= False;
     eList.SetFocus;
end;

procedure TForm_SQLdefine.eListExit(Sender: TObject);
          var SQLno: integer;
begin
     SQLno:= lbxSQL.ItemIndex;
     if (eList.ReadOnly = False) and (SQLno <> -1) then begin
        lbxSQL.Items.Strings[SQLno]:= eList.Text;
        lbxName.Items.Strings[SQLno]:= '['+trim(lbxName.Items.Strings[SQLno])+']';
        eList.ReadOnly:= True;
        lbxSQL.SetFocus;
     end;
end;

procedure TForm_SQLdefine.btn_EditClick(Sender: TObject);
          var NameNo: integer;
begin
     addType:= 'INSERT';
     NameNo:= lbxName.ItemIndex;
     if NameNo=-1 then begin
        Application.MessageBox('пܤ@ձyz','~',MB_ICONERROR+MB_OK);
        exit;
     end;
     if Form_SQLdefine.AddSQL then begin
        lbxName.Items.Strings[NameNo]:= SQLname;
        lbxSQL.Items.Strings[NameNo] := SQLscript;
     end;
end;

procedure TForm_SQLdefine.cbxSelectClick(Sender: TObject);
          var i: integer;
begin
     if not cbxSelect.Checked then nSQLfield:=' * '
     else begin
        nSQLfield:= '';
        for i:= 0 to aQueryCount-1 do begin
            if i = 0 then nSQLfield:= aftAry[i].fdfieldName
            else nSQLfield:= nSQLfield+', '+aftAry[i].fdfieldName;
        end;
     end;
end;

end.
