{******************************************************************************}
{ UNIT:    Delay                                                               }
{ CLASS:   TDelay                                                              }
{ Purpose: NSleep(MSeconds:Dword) \, Sleep@QҰʷ|Ҧmessage}
{          , QΥhiHϨLb즳ʧ@U, 橵𪺰ʧ@C  }
{          ɶHp, 1=1000@C                                  }
{          3/5즳\õLk, gק[WSetActiveSetSecond\           }
{          ץproperityLkקƤactive\~, ]TF   }
{          𪺬ƤΫOLʧ@`, 𧹲۰active              }
{                                                                              }
{ Author:  v Phoenix D.                             	               }
{ E-Mail:  phoenixd@ms2.hinet.net                                              }
{ Create:  05/05/2000                                                          }
{ Edited:  03/05/2001                                                          }
{******************************************************************************}

unit Delay;

interface

uses
  Windows, SysUtils, Classes, Messages, Forms;

type
    TDelay = class(TComponent)
    private
       Fseconds: LongInt;
       FActive: boolean;
       procedure Delay(MSecs: Longint);
       procedure SetActive(Value: Boolean);
       procedure SetSecond(Value: LongINt);

    public
       constructor Create(AOwner: TComponent); override;

    published
       property MSeconds: LongInt read FSeconds write SetSecond;
       property Active: Boolean read FActive write SetActive;
    end;

procedure Register;

implementation

constructor TDelay.Create(AOwner: Tcomponent);
begin
     inherited Create(AOwner);
     FSeconds:=1000;
     FActive:=False;
end;

procedure TDelay.SetActive(Value: Boolean);
begin
     if FActive <> Value then Factive:= Value;
     if FActive = True then Delay(FSeconds);
end;

procedure TDelay.SetSecond(Value: LongInt);
begin
     if FSeconds <> Value then FSeconds:= Value;
end;

procedure TDelay.Delay(MSecs: Longint);
          var beginTime: Longint;
              endTime: LongInt;
begin
     beginTime:= GetTickCount;
     repeat
        endTime:= GetTickCount;
        Application.ProcessMessages;
     until (endTime - beginTime) >= MSecs;
     FActive:= False;
end;

procedure Register;
begin
  RegisterComponents('System', [TDelay]);
end;

end.
